import {
  ClassType,
  PropertyType,
} from '@loafer/core/constants/types';

import ApplicationContext from '@loafer/context/ApplicationContext';

import DefaultPouchFactory from '@loafer/pouches/factory/implement/DefaultPouchFactory';

class DefaultAppContext implements ApplicationContext {
  private readonly pouchFactory: DefaultPouchFactory;

  public constructor() {
    this.pouchFactory = new DefaultPouchFactory();
  }

  public getPouchFactory(): DefaultPouchFactory {
    return this.pouchFactory;
  }

  public getPouch(qualifier: PropertyType, clazz: ClassType, ...args: any[]): any {
    return this.pouchFactory.getPouch(qualifier, clazz, args);
  }
  public getPouchByClass(clazz: ClassType, qualifier: PropertyType, ...args: any[]): any {
    return this.pouchFactory.getPouchByClass(clazz, qualifier, args);
  }

}

export default DefaultAppContext;
