import {
  PropertyType,
} from '@loafer/core/constants/types';

import {
  Decorator,
  DecoratorHandler,
 } from '@loafer/core/decorator';

import {
  Class,
} from '@loafer/core/reflect';

import {
  InjectableAnnotation,
} from '@loafer/pouches/decorator/Injectable';

export class ConfigurationAnnotation extends InjectableAnnotation implements DecoratorHandler {
  public constructor(qualifier?: PropertyType) {
    super(qualifier);
  }
  public onClassDecorator = <TFunction extends Function>(clazz: Class, target: TFunction): TFunction | void => {
    console.log('Configuration');
  }

}

export const Configuration = Decorator.create(ConfigurationAnnotation);

export default Configuration;
