import {
  ClassType,
  PropertyType,
} from '@loafer/core/constants/types';

import {
  Decorator,
  DecoratorHandler,
 } from '@loafer/core/decorator';

import {
  Class,
} from '@loafer/core/reflect';

export interface PouchConfig {
  qualifier?: PropertyType;
  type?: ClassType;
}

export class PouchAnnotation implements DecoratorHandler {
  private readonly Qualifier: PropertyType;
  private readonly Type: ClassType;
  public constructor(config: PouchConfig = {}) {
    this.Qualifier = config.qualifier;
    this.Type = config.type;
  }

  public onMethodDecorator = <T>(clazz: Class, target: Object, propertyKey: PropertyType,
                                 descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void => {
    console.log('Pouch');
  }
}

export const Pouch = Decorator.create(PouchAnnotation);

export default Pouch;
