import {
  ClassType,
  PropertyType,
} from '@loafer/core/constants/types';

import {
  Decorator,
  DecoratorHandler,
 } from '@loafer/core/decorator';

import {
  Class,
} from '@loafer/core/reflect';

export class ValueAnnotation implements DecoratorHandler {
  private readonly Value: PropertyType;

  public constructor(value: PropertyType) {
    this.Value = value;
  }

  public onPropertyDecorator = (clazz: Class, target: Object, propertyKey: PropertyType): void => {
    console.log('Value');
  }
  public onParameterDecorator = (clazz: Class, target: Object, propertyKey: PropertyType, parameterIndex: number): void => {
    console.log('Value');
  }

}

export const Value = Decorator.create(ValueAnnotation);

export default Value;
