import {
  ClassType,
  PropertyType,
} from '@loafer/core/constants/types';

import PouchDefinition from '@loafer/pouches/factory/config/PouchDefinition';

interface PouchDefinitionRegistry {
  registerPouchDefinition(pouchDefinition: PouchDefinition): void;

  removePouchDefinition(qualifier: PropertyType, clazz?: ClassType): void;
  getPouchDefinition(qualifier: PropertyType, clazz?: ClassType): PouchDefinition;
  hasPouchDefinition(qualifier: PropertyType, clazz?: ClassType): boolean;

  removePouchDefinitionByClass(clazz: ClassType, qualifier?: PropertyType): void;
  getPouchDefinitionByClass(clazz: ClassType, qualifier?: PropertyType): PouchDefinition;
  hasPouchDefinitionByClass(clazz: ClassType, qualifier?: PropertyType): boolean;
}

export default PouchDefinitionRegistry;
